// using System;
// using System.Collections.Generic;
// using System.Collections.Immutable;
// using System.Linq;
// using System.Threading.Tasks;
// using InternshipSystem.Core;
// using InternshipSystem.Core.Entity.Internship;
// using InternshipSystem.Core.UglyOrmArtifacts;
// using InternshipSystem.Repository.Model;
// using Microsoft.EntityFrameworkCore;
//
// namespace InternshipSystem.Repository
// {
//     public class DatabaseFiller
//     {
//         public DatabaseFiller(InternshipDbContext context)
//         {
//             Context = context;
//         }
//
//         public InternshipDbContext Context { get; }
//
//         public async Task FillCompany()
//         {
//             var companies = new List<CompanyReadModel>
//             {
//                 new CompanyReadModel
//                 {
//                     Name = "Intel",
//                     SiteAddress = new Uri("https://www.intel.com/content/www/us/en/jobs/locations/poland.html"),
//                     Nip = "9570752316",
//                     Range = RangeOfActivity.International,
//                     Branches = new List<BranchOfficeReadModel>
//                     {
//                         new BranchOfficeReadModel
//                         {
//                             City = "Gdańsk",
//                             Street = "ul. Słowackiego",
//                             Building = "173",
//                             PostalCode = "80-298",
//                             Country = "Poland",
//                         },
//                         new BranchOfficeReadModel
//                         {
//                             City = "Gdańsk",
//                             Street = "Jana z Kolna",
//                             Building = "11",
//                             PostalCode = "80-001",
//                             Country = "Poland",
//                         },
//                         new BranchOfficeReadModel
//                         {
//                             City = "Boston",
//                             Street = "State St",
//                             Building = "53",
//                             PostalCode = "MA 02109",
//                             Country = "Stany Zjednoczone",
//                         }
//                     }
//                 },
//                 new CompanyReadModel
//                 {
//                     Name = "Asseco Poland",
//                     SiteAddress = new Uri("http://pl.asseco.com"),
//                     Nip = "5842068320",
//                     Range = RangeOfActivity.National,
//                     Branches = new List<BranchOfficeReadModel>
//                     {
//                         new BranchOfficeReadModel
//                         {
//                             City = "Gdańsk",
//                             Street = "ul. Podolska",
//                             Building = "21",
//                             PostalCode = "81-321",
//                             Country = "Poland"
//                         },
//                         new BranchOfficeReadModel
//                         {
//                             City = "Wrocław",
//                             Street = "Traugutta",
//                             Building = "1/7",
//                             PostalCode = "50-449",
//                             Country = "Poland"
//                         }
//                     }
//                 }
//             };
//             await Context.Companies.AddRangeAsync(companies);
//             await Context.SaveChangesAsync();
//         }
//
//         public async Task FillStudents()
//         {
//             var interns = new List<Student>
//             {
//                 new Student
//                 {
//                     FirstName = "Jan",
//                     LastName = "Kowalski",
//                     AlbumNumber = 123456,
//                     Email = "s123456@student.pg.edu.pl",
//                     Semester = 4,
//                 },
//                 new Student
//                 {
//                     FirstName = "Adam",
//                     LastName = "Kołek",
//                     AlbumNumber = 102137,
//                     Email = "s102137@student.pg.edu.pl",
//                     Semester = 6,
//                 }
//             };
//             await Context.Students.AddRangeAsync(interns);
//             await Context.SaveChangesAsync();
//         }
//
//         public async Task FillInternshipTypes()
//         {
//             var internshipTypes = new List<InternshipType>
//             {
//                 new InternshipType
//                 {
//                     Type = "FreeInternship",
//                     Description = "Praktyka bezpłatna",
//                 },
//                 new InternshipType
//                 {
//                     Type = "GraduateInternship"
//                 },
//                 new InternshipType
//                 {
//                     Type = "FreeApprenticeship"
//                 },
//                 new InternshipType
//                 {
//                     Type = "PaidApprenticeship",
//                     Description = "np. przemysłowy"
//                 },
//                 new InternshipType
//                 {
//                     Type = "ForeignInternship",
//                     Description = "np. IAESTE, ERASMUS"
//                 },
//                 new InternshipType
//                 {
//                     Type = "UOP"
//                 },
//                 new InternshipType
//                 {
//                     Type = "UD"
//                 },
//                 new InternshipType
//                 {
//                     Type = "UZ"
//                 },
//                 new InternshipType
//                 {
//                     Type = "Other",
//                     Description = "Należy wprowadzić samodzielnie"
//                 }
//             };
//             await Context.InternshipTypes.AddRangeAsync(internshipTypes);
//             await Context.SaveChangesAsync();
//         }
//
//         public async Task FillSubjects()
//         {
//             var subjects = new List<InternshipSubject>
//             {
//                 new InternshipSubject
//                 {
//                     Description = "Modelowanie baz danych"
//                 },
//                 new InternshipSubject
//                 {
//                     Description = "Oprogramowywanie kart graficznych"
//                 },
//                 new InternshipSubject
//                 {
//                     Description = "Projektowanie UI"
//                 }
//             };
//             await Context.Subjects.AddRangeAsync(subjects);
//             await Context.SaveChangesAsync();
//         }
//
//         public async Task FillEditions()
//         {
//             var editions = new List<EditionReadModel>
//             {
//                 new EditionReadModel
//                 {
//                     EditionStart = new DateTime(2000, 5, 10),
//                     EditionFinish = new DateTime(2000, 11, 10),
//                     ReportingStart = new DateTime(2000, 9, 30),
//                     AvailableSubjects = new List<EditionSubject>
//                     {
//                         new EditionSubject
//                         {
//                             InternshipId = Context.Subjects
//                                 .First(i => i.Description.Equals("Modelowanie baz danych"))
//                                 .Id,
//                         },
//                         new EditionSubject
//                         {
//                             InternshipId = Context.Subjects
//                                 .First(i => i.Description.Equals("Oprogramowywanie kart graficznych"))
//                                 .Id
//                         },
//                         new EditionSubject
//                         {
//                             InternshipId = Context.Subjects
//                                 .First(i => i.Description.Equals("Projektowanie UI"))
//                                 .Id
//                         }
//                     }.ToImmutableList(),
//                     Course = new Course
//                     {
//                         Name = "Informatyka",
//                     }
//                 }
//             };
//             await Context.Editions.AddRangeAsync(editions);
//             await Context.SaveChangesAsync();
//         }
//
//         public async Task FillInternShips()
//         {
//             var intenrships = new List<InternshipReadModel>
//             {
//                 new InternshipReadModel
//                 {
//                     Student = Context.Students.First(i => i.AlbumNumber.Equals(123456)),
//                     InternshipRegistration = new InternshipRegistrationReadModel()
//                     {
//                         Company = Context.Companies.First(c => c.Nip.Equals("9570752316")), //Intel
//                         Type = Context.InternshipTypes.First(t => t.Type.Equals("UOP")),
//                         Start = new DateTime(2000, 7, 1),
//                         End = new DateTime(2000, 8, 30),
//                         State = DocumentState.Submitted,
//                         BranchAddress =
//                             Context.Companies
//                                 .Include(c => c.Branches)
//                                 .First(c => c.Nip.Equals("9570752316"))    
//                                 .Branches
//                                 .First(),
//                     },
//                     InternshipProgram = new InternshipProgramReadModel()
//                     {
//                         FirstName = "Horacy",
//                         LastName = "Wościcki",
//                         Email = "howos@intel.com",
//                         PhoneNumber = "605-555-555",
//                         ChosenSubjects = new List<ProgramSubject>
//                         {
//                             new ProgramSubject
//                             {
//                                 InternshipSubjectId = 
//                                     Context.Subjects
//                                         .First(s => s.Description.Equals("Projektowanie UI"))
//                                         .Id
//                             },
//                             new ProgramSubject
//                             {
//                                 InternshipSubjectId =
//                                     Context.Subjects
//                                         .First(s => s.Description.Equals("Oprogramowywanie kart graficznych"))
//                                         .Id
//                             }
//                         }
//                     },
//                 },
//                 new InternshipReadModel
//                 {
//                     Student = Context.Students.First(i => i.AlbumNumber == 102137),
//                     InternshipRegistration = new InternshipRegistrationReadModel()
//                     {
//                         Company = Context.Companies.First(c => c.Nip.Equals("5842068320")), //Asseco
//                         Type = Context.InternshipTypes.First(t => t.Type.Equals("UZ")),
//                         Start = new DateTime(2000, 7, 1),
//                         End = new DateTime(2000, 8, 30),
//                         State = DocumentState.Submitted,
//                         BranchAddress =
//                             Context.Companies
//                                 .Include(c => c.Branches)
//                                 .First(c => c.Nip.Equals("5842068320"))
//                                 .Branches
//                                 .First(),
//                     },
//                     InternshipProgram = new InternshipProgramReadModel()
//                     {
//                         FirstName = "Henryk",
//                         LastName = "Polaciński",
//                         Email = "hepol@asseco.pl",
//                         PhoneNumber = "555-525-545",
//                         ChosenSubjects = new List<ProgramSubject>
//                         {
//                             new ProgramSubject
//                             {
//                                 InternshipSubjectId =
//                                     Context.Subjects
//                                         .First(s => s.Description.Equals("Modelowanie baz danych"))
//                                         .Id
//                             }
//                         },
//                     },
//                 },
//             };
//             await Context.Internships.AddRangeAsync(intenrships);
//             await Context.SaveChangesAsync();
//         }
//     }
// }